/**
 This code demonstrate the usage of OLED display (SSD1306 i2c ) with stm32f4xx mcu
 The utilitiezed mcu is stm32f407vetx and the code is ddeveloped using keil uvision software 
 The code use bare metal method ( direct register manipulation ) to drive the oled display 
 The setting for the mcu was as following
 core speed =100MHz
 i2c speed = 1MHz
 
 */


#include "delay.h"
#include "oled.h"
#include "stdio.h"
#include "MPU9250.h"

extern void SysClockConfig(void);
float acc_x,acc_y,acc_z;
char zz[30];

#define update_rate 100 //update rate of OLED display

uint64_t previous;

int main(void)
{
	
SysClockConfig();
systick_init_ms(100000000);
SSD1306_Init();
MPU9250_beginAccel(ACC_FULL_SCALE_16_G);	
	
	
while(1)
{
MPU9250_accelUpdate();
acc_x=MPU9250_accelX();
acc_y=MPU9250_accelY();
acc_z=MPU9250_accelZ();
if(millis()-previous>update_rate){
previous=millis();
//SSD1306_Clear();
SSD1306_GotoXY (0,0);
sprintf(zz,"Acc X=%0.3f",acc_x);
SSD1306_Puts (zz, &Font_11x18, 1);

SSD1306_GotoXY (0,20);
sprintf(zz,"Acc Y=%0.3f",acc_y);
SSD1306_Puts (zz, &Font_11x18, 1);

SSD1306_GotoXY (0,40);
sprintf(zz,"Acc Z=%0.3f",acc_z);
SSD1306_Puts (zz, &Font_11x18, 1);	
	
SSD1306_UpdateScreen();
}

}

}